{% extends 'site_base.html' %}
{% load static %}
{% load crispy_forms_tags %}
{% load humanize %}
{% load custom_tags %}
{% block content %}
    <style>
        .table-hide{
            display: none;
        }

        .scheme-input {
            width: 100%;
        }

        .summary-head {
            display: -webkit-inline-box;
            margin: 3px 0 0 8px !important;
            vertical-align: top;
        }
        .status-image {
            position: absolute;
            margin: 0 auto 0 15%;
        }
        table.table-bordered tbody tr:nth-child(2n+1){
            background: #03a9f470;
        }
    </style>
    <head>
        <!--<link rel="stylesheet" type="text/css" href="{% static 'css/new-style.css' %}">-->
        <title>{% block title %} SR Order Detail {% endblock %}</title>
    </head>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <div class="col-order-detail">
        <div class="row row-order">
            <div class="col-md-4">
                <span id="btn-back" class="glyphicon glyphicon-circle-arrow-left"></span>
                <h2 class="summary-head">
                    Order Summary
                    {% if dms_number %}
                        ({{order_id}}, {{order_date|date|default:"---"}}, {{dms_number}})
                    {% else %}
                        ({{order_id}}, {{order_date|date|default:"---"}})
                    {% endif %}
                </h2>
            </div>
            <div class="col-md-8" style="text-align: right;">
                <button type="button" class="btn btn-warning">
                    <label style="color: #424242;margin-bottom: 0;">Credit days left:</label>
                    <b>{{dbm.credit_days|default:"0"}}</b>
                </button>

                <button type="button" class="btn btn-info">
                    <label style="color: #424242;margin-bottom: 0;">Credit Limit:</label>
                    <b>₹ {{dbm.max_outstanding_threshold|floatformat:2|intcomma}}</b>
                </button>

                <button type="button" class="btn btn-danger">
                    <label style="color: #424242;margin-bottom: 0;">Min order:</label>
                    <b>₹ {{dbm.min_order_amount|floatformat:2|intcomma}}</b>
                </button>

                {% if outstanding_flag == True %}
                    <button type="button" class="btn btn-success">
                        <label style="color: #424242;margin-bottom: 0;">Outstanding:</label>
                        <b>₹ {{outstanding|floatformat:2|intcomma}}</b>
                    </button>
                {% endif %}

                <button type="button" class="btn btn-default">
                    <i class="fa fa-file-pdf-o" aria-hidden="true" style="color: red"></i>
                    <b style="color: #424242"> PDF</b>
                </button>

                <button type="button" class="btn btn-default">
                    <a href="/"><span class="glyphicon glyphicon-home"></span> <b style="color: #424242"> Home</b></a>
                </button>
            </div>
        </div>

        <div class="row">
            <div class="col-xs-12 col-sm-4 col-md-4">
                <table class="table table-bordered table-responsive table-striped allowance-table table-c-detail">
                    <thead>
                        <tr>
                            <th colspan="2">
                                Customer Detail (
                                <a target="_blank" href="{% url 'dealer_profile' dealer.dealer_id %}">
                                    {{dealer.owner_name|default:"---"}}
                                </a>)
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>{{dealer.company_name|default:"--"}}</td>
                            <td>{{dealer.primary_contact|default:"--"}}</td>
                        </tr>
                        <tr>
                            <td>{{dealer.company_address|default:"--"}}</td>
                            <td>{{dealer.email|default:"--"}}</td>
                        </tr>
                        <tr>
                            <td>Credit days: {{dbm.credit_days|default:"--"}}</td>
                            <td>Thresshold: ₹ {{dbm.max_outstanding_threshold|floatformat:2|intcomma}}</td>
                        </tr>
                        <tr>
                            <td>GST</td>
                            <td>{{dealer.gst_no|default:"--"}}</td>
                        </tr>
                        <tr>
                            <td>PAN</td>
                            <td>{{dealer.pan_no|default:"--"}}</td>
                        </tr>
                    </tbody>
                </table>
            </div>

            <div class="col-xs-12 col-sm-8 col-md-8">
                <table class="table table-bordered table-responsive table-striped allowance-table">
                    <thead>
                        <tr>
                            <th colspan="3">Order details - Before SR Scheme</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>DP</td>
                            <td style="text-align:right;">₹ {{totaldp|floatformat:2|intcomma|default:"0"}}</td>
                            <td></td>
                        </tr>
                        <tr>
                            <td>Net After Allowance(including GST)</td>
                            <td style="text-align:right;">₹ {{totalafterallowance|floatformat:2|intcomma|default:"0"}}</td>
                            <td><!--{{percent}} % Allowance--></td>
                        </tr>
                        <tr>
                            <td>Pre GST Cost</td>
                            <td style="text-align:right;">₹ {{totalpregst|floatformat:2|intcomma|default:"0"}}</td>
                            <td></td>
                        </tr>
                        <tr>
                            <!--<td>CGST</td>-->
                            <td>
                                CGST
                                <img src="{% static 'img/' %}{{status_image}}.png" class="status-image">
                            </td>
                            <td style="text-align:right;">₹ {{totalcgst|floatformat:2|intcomma|default:"0"}}</td>
                            <td></td>
                        </tr>
                        <tr>
                            <td>SGST</td>
                            <td style="text-align:right;">₹ {{totalsgst|floatformat:2|intcomma|default:"0"}}</td>
                            <td></td>
                        </tr>
                        <tr>
                            <td>Invoice Bill Value</td>
                            <td class="success" style="text-align:right;">₹ {{totalbill|floatformat:2|intcomma|default:"0"}}</td>
                            <td></td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>

        {% if cc_status == True %}
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12 for-sr-only">
                    <h2> Applied Schemes - by ({{total.sr_name}}, {{total.sr_contact}})</h2>
                    <table class="table table-bordered table-responsive table-striped brand-table">
                        <thead>
                            <tr>
                                <th>SKU Code</th>
                                <th>QTY.</th>
                                <th>DP per unit</th>
                                <th>Allowance</th>
                                <th title="dp - allowance">Value after allowance including tax</th>
                                <th>TieUp</th>
                                <th>Sell through</th>
                                <th title="pregst - (tieup + sell through)">Final value</th>
                                <th title="final value * quantity">Total Value</th>
                                <!--<th>BBP</th>-->
                            </tr>
                        </thead>
                        <tbody>
                            {% for item in details %}
                                <tr>
                                    <td>{{item.skucode}}</td>
                                    <td>{{item.quantity}}</td>
                                    <td style="text-align:right;">₹ {{item.dp|floatformat:2|intcomma}}</td>
                                    <td style="text-align:right;">₹ {{item.allowance_value|floatformat:2|intcomma}}</td>
                                    <td style="text-align:right;">₹ {{item.total_pre|floatformat:2|intcomma}}</td>
                                    <td style="text-align:right;">₹ {{item.tieup_value|floatformat:2|intcomma}}</td>
                                    <td style="text-align:right;">₹ {{item.sell_through_value|floatformat:2|intcomma}}</td>
                                    <td style="text-align:right;">₹ {{item.total_pre_gst|floatformat:2|intcomma}}</td>
                                    <td style="text-align:right;">₹ {{item.final_total|floatformat:2|intcomma}}</td>
                                    <!--<td style="text-align:right;">₹ {{item.bbp|floatformat:2|intcomma}}</td>-->
                                </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        {% elif cc_status == False %}
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12 for-sr-only">
                    <h2> Apply Scheme - For SR Only</h2>
                    <table class="table table-bordered table-responsive table-striped brand-table">
                        <thead>
                            <tr>
                                <th>SKU Code</th>
                                <th>QTY.</th>
                                <th>DP per unit</th>
                                <th>Allowance</th>
                                <th title="dp - allowance">Value after allowance including tax</th>
                                <th>TieUp</th>
                                <th>Sell through</th>
                                <th title="pregst - (tieup + sell through)">Final value</th>
                                <th title="final value * quantity">Total Value</th>
                                <th>BBP</th>
                            </tr>
                        </thead>
                        <tbody id="products_body">

                        </tbody>
                    </table>
                </div>
            </div>
        {% endif %}

        <div class="row">
            <div class="col-xs-12 col-sm-4 col-md-4"></div>
            <div class="col-xs-12 col-sm-8 col-md-8">
                <table class="table table-bordered table-responsive table-striped allowance-table table-hide">
                    <thead>
                        <tr>
                            <th>Order details - After SR Scheme</th>
                            <th></th>
                            <th></th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>Invoice bill value</td>
                            <td id="dp" style="text-align:right;"></td>
                            <td></td>
                        </tr>
                        <tr>
                            <td>Less Total TieUp</td>
                            <td id="gst" style="text-align:right;"></td>
                            <td id="allowance"></td>
                        </tr>
                        <tr>
                            <td>Less Total sell through</td>
                            <td id="pre" style="text-align:right;"></td>
                            <td id="tieup"></td>
                        </tr>
                        <tr>
                            <td title="total bill - (tieup + sell through)">Invoice Bill Value</td>
                            <td id="cgst" style="text-align:right;"></td>
                            <td></td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>

        {% if cc_status == False %}
        {% if request.user.is_superuser%}
                    {% elif request.user|has_group:"DEL" %}
                      {% else %}
        <div class="row">
            <div class="col-md-12 text-right">
                <button id="submit" type="button" class="order-btn apply-btn">
                    <a href="javascript:void(0);">Apply Scheme</a>
                </button>
                <button id="edit_btn" type="button" class="order-btn edit-btn table-hide">
                    <a href="javascript:void(0);">Edit Scheme</a>
                </button>
                <button type="button" class="order-btn send-dealer">
                    <a href="javascript:void(0);">Send to Dealer</a>
                </button>
            </div>
        </div>
        {% endif %}
        {% endif %}
        {% if cc_status %}
        <div class="row">
            <div class="col-xs-12 col-sm-6 col-md-6">
                <h2>Credit Notes</h2>
                <table class="table table-bordered table-responsive table-striped allowance-table table-c-detail">
                    <thead>
                        <tr>
                            <th colspan="3">
                                Tieup and SellThrough - Applied by {{credit_notes.sr_name|default:"---"}}
                                ({{credit_notes.sr_contact_no|default:"---"}})
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                    {% for item in credit_notes.tieup %}
                        <tr>
                            <td colspan="2" style="text-align: right;">
                                <!--{{item.applyed_discount}}-->
                                ₹ {{item.applyed_discount_amount|floatformat:2|intcomma}}
                                <!--/ {{item.max_discount}}-->
                            </td>
                            <td>
                                Applied on {{item.tieup_date|date|default:"---"}}
                            </td>
                        </tr>
                    {% endfor %}
                    {% for sell in credit_notes.sell_through %}
                        <tr>
                            <td colspan="2" style="text-align: right;">
                                ₹ {{sell.total_sell_amount|floatformat:2}}
                                <!--/ {{sell.max_amount|floatformat:2}}-->
                            </td>
                            <td>
                                Applied on {{sell.sell_through_date|date}}
                            </td>
                        </tr>
                    {% endfor %}
                    </tbody>
                    <tfoot>
                    <tr>
                        <td colspan="2" style="text-align:right;">
                            <!--{{credit_notes.total_tieup_discount}}-->
                            Total: ₹ {{credit_notes.grand_total|floatformat:2|intcomma}}
                        </td>
                    </tr>
                    </tfoot>
                </table>

                <!-- <table class="table table-bordered table-responsive table-striped allowance-table">
                    <thead>
                        <tr>
                            <th colspan="2">
                                SellThrough - Applied by {{credit_notes.sr_name}} ({{credit_notes.sr_contact_no}})
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                    {% for sell in credit_notes.sell_through %}
                    <tr>
                        <td style="text-align: right;">
                            ₹ {{sell.total_sell_amount|floatformat:2}}
                        </td>
                        <td>
                            Applied on {{sell.sell_through_date|date}}
                        </td>
                    </tr>
                    {% endfor %}
                    </tbody>
                    <tfoot>
                    <tr>
                        <td style="text-align: right;">
                            Total SellThrough: ₹ {{credit_notes.total_sell|floatformat:2|intcomma}}
                        </td>
                    </tr>
                    </tfoot>
                </table>

                <table class="table table-bordered table-responsive table-striped allowance-table table-c-detail">
                    <thead>
                        <tr>
                            <td style="text-align: right;width:52%">
                                <b>Grand Total: ₹ {{credit_notes.grand_total|floatformat:2|intcomma}}</b>
                            </td>
                            <td></td>
                        </tr>
                    </thead>
                </table>

                <table style="display: none;" class="table table-bordered table-responsive table-striped allowance-table table-c-detail">
                    <thead>
                        <tr>
                            <th colspan="3">Cash Discount</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td colspan="2">50.00</td>
                            <td>Dec. 08, 2018</td>
                        </tr>
                        <tr>
                            <td colspan="2">75.00</td>
                            <td>Dec. 09, 2018</td>
                        </tr>
                        <tr>
                            <td colspan="2">100.00</td>
                            <td>Dec. 10, 2018</td>
                        </tr>
                    </tbody>
                </table> -->
            </div>
        </div>
        {% endif %}

        {% if history %}
            <!-- <div class="row">
                <div class="col-xs-12 col-sm-6 col-md-6">
                    <h3 style="font-size: 20px;font-weight: 600;">
                        Order Log (OrderID: {{order_id}}, DMS Ordernumber: {{dms_number}})
                    </h3>
                    <table class="table table-bordered table-responsive table-striped allowance-table table-c-detail">
                        <thead>
                            <tr>
                                <th>Status</th>
                                <th>Date</th>
                            </tr>
                        </thead>
                        <tbody>
                        {% for item in orderHistory %}
                            <tr>
                                <td>
                                    {{item.order_status}}
                                </td>
                                <td>
                                    {{item.created_on|date|default:"---"}}
                                </td>
                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div> -->

            <div class="row">
                <div class="col-xs-12 col-sm-6 col-md-6">
                    <h3 style="font-size: 20px;font-weight: 600;">
                        Order Log (OrderID: {{order_id}}, DMS Ordernumber: {{dms_number}})
                    </h3>
                    <table class="table table-bordered table-responsive table-striped allowance-table table-c-detail">
                        <tbody>
                        {% for item in orderHistory %}
                            <tr>
                                <td>
                                    {% if item.order_status == 'Processing' %}
                                        Dealer <a target="_blank" href="{% url 'dealer_profile' dealer.dealer_id %}">
                                        {{dealer.owner_name|default:"---"}}</a>
                                        process order(Order No: {{order_id}}) on {{item.created_on}}

                                    {% elif item.order_status == 'SchemeApplied' %}
                                        SR <a href="javascript:void(0);">{{total.sr_name|default:"---"}}</a>
                                        proceed order(Order No: {{order_id}}) and applied all Sell Through
                                        and Tieup and send it to Dealer
                                        <a target="_blank" href="{% url 'dealer_profile' dealer.dealer_id %}">
                                        {{dealer.owner_name|default:"---"}}</a> for confirmation on {{item.created_on}}

                                    {% elif item.order_status == 'OrderPlaced' %}
                                        Dealer <a target="_blank" href="{% url 'dealer_profile' dealer.dealer_id %}">
                                        {{dealer.owner_name|default:"---"}}</a>
                                        placed order(Order No: {{order_id}}) on {{item.created_on}}

                                    {% elif item.order_status == 'InWarehouse' %}
                                        Warehouse Admin reviewed order(Order No: {{order_id}}) on {{item.created_on}}
                                        and send it to &lt;{{warehouse}}&gt;
                                        &lt;{{manager}}&gt;

                                    {% elif item.order_status == 'Dispatched' %}
                                        Warehouse User <a href="javascript:void(0);">
                                        {{total.sr_name|default:"---"}}</a> dispatched order(Order No: {{order_id}})
                                        on {{item.created_on}}

                                    {% elif item.order_status == 'Deleted' %}
                                        Order(Order No: {{order_id}}) canceled by <a href="javascript:void(0);">
                                        {{item.created_by.first_name}} {{item.created_by.last_name}}</a>
                                        on {{item.created_on}}

                                    {% elif item.order_status == 'Reject' %}
                                        Order(Order No: {{order_id}}) rejected by <a href="javascript:void(0);">
                                        {{item.created_by.first_name}} {{item.created_by.last_name}}</a>
                                        on {{item.created_on}}

                                    {% elif item.order_status == 'OnHold' %}
                                        Order(Order No: {{order_id}}) on hold <a href="javascript:void(0);">
                                        {{item.created_by.first_name}} {{item.created_by.last_name}}</a>
                                        on {{item.created_on}}

                                    {% elif item.order_status == 'Delivered' %}
                                        Order(Order No: {{order_id}}) delivered by <a href="javascript:void(0);">
                                        {{item.created_by.first_name}} {{item.created_by.last_name}}</a>
                                        on {{item.created_on}}

                                    {% elif item.order_status == 'PartialDispatched' %}
                                        Order(Order No: {{order_id}}) partial dispatched by <a href="javascript:void(0);">
                                        {{item.created_by.first_name}} {{item.created_by.last_name}}</a>
                                        on {{item.created_on}}
                                    {% endif %}
                                </td>
                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        {% endif %}

    </div>

    <div class="row">
        <div class="col-md-12 text-right">
          <h3 style="text-align:left;">Leave a Comment</h3>
            <textarea rows="4" cols="147" name="ordernote" id="ordernote" placeholder="Add a comment..."></textarea>
            <button type="submit" class="ordercomment" name="commentbtn" id="commentbtn" style="color: white;padding: 6px 25px;background: rgb(5, 123, 202);border: 0;border-radius: 4px;">Post a Comment</button>
        </div>
    </div>

    <div class="modal modal-default fade" id="modal-info">
        <div class="modal-dialog" style="width: 1000px;">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    <h4 class="modal-title">Our Schemes</h4>
                </div>
                <div class="modal-body">
                    <table id="scheme" class="table table-bordered table-responsive">
                        <thead>
                            <tr>
                                <th>#<input style="display:none;" id='main_checkbox' type='checkbox' onclick='checkAllCheckBox()'></th>
                                <th>Scheme Name</th>
                                <th style="text-align: right;">Max Discount (%)</th>
                                <th>Discount (%)</th>
                                <th style="text-align: right;">Max Discount (AMT)</th>
                                <th>Discount (AMT)</th>
                                <th>Scheme Code</th>
                                <th>End Date</th>
                            </tr>
                        </thead>
                        <tbody id="schemes_body">
                        </tbody>
                    </table>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-primary pull-left" data-dismiss="modal">Close</button>
                    <!--<button type="button" class="btn btn-primary" onclick='showCheckedCheckBoxData()'>Checkbox Data</button>-->
                    <button id="apply_scheme" type="button" class="btn btn-primary">Apply Schemes</button>
                </div>
            </div>
        </div>
    </div>

    <div id="modal-danger" class="modal fade modal-alert modal-danger">
        <div class="modal-dialog modal-dialog-new">
            <div class="modal-content modal-content-new">
                <div class="modal-header modal-header-new" style="background-color:#e46050 !important">
                    <i class="fa fa-times-circle"></i>
                </div>
                <div class="modal-title modal-title-new">Delete</div>
                <div class="modal-body modal-body-new" style="color:#444 !important;background-color:#fff !important">Are you sure you want to delete?</div>
                <div class="modal-footer modal-footer-new" style="background-color:#fff !important;border-top:1px solid #fff !important">
                    <a id="confirm-id" class="btn btn-danger btn-3d">Yes</a>
                    <a class="btn btn-info btn-3d" data-dismiss="modal">No</a>
                </div>
            </div>
        </div>
    </div>

{% endblock %}

{% block extra_script_block %}
    {{ block.super }}

    <script type="text/javascript">
        var order = '';
        var checkedData = [];
        $(document).ready(function(){

            // $('input["type=checkbox"]').css('display', block);

            $('body').addClass('sidebar-collapse');
            // $('ul.sidebar-menu').remove();
            $('ul.sidebar-menu').css('display', 'none');

            $('.sidebar-toggle').click(function(){
                $('ul.sidebar-menu').css('display', 'block');
            })

            $('.content-header').remove();

            var parts = window.location.href.split("/");
            order = parts[parts.length-1];

            // schemes_body
            $(document).on('click', '[id^="showScheme_"]', function() {

                checkedData = [];
                var currid = this.id.split('_')[1];
                $.ajax({
                    type:'get',
                    url:'/user/get_order_schemes?order='+order+'&product='+currid,
                    success: function(res) {

                        var table = "";
                        $.each(res["data"], function(index, value) {
                            var checkbox = '<input id="check_'+value["order_id"]+'_'+value["scheme_id"]+'" class="checkClass" value="'+value["scheme_id"]+'" type="checkbox" onclick="pushValue(this.id)">';
                            var percent_input = '<input id="percent_'+value["order_id"]+'_'+value["scheme_id"]+'" class="scheme-input" type="number" min="0" max="'+value["discount_percent"]+'" placeholder="%">';
                            var amount_input = '<input id="amount_'+value["order_id"]+'_'+value["scheme_id"]+'" class="scheme-input" type="number" min="0" max="'+value["discount_amount"]+'" placeholder="INR">';

                            table += '<tr><td>'+checkbox+'</td><td>'+value["scheme_name"]+'</td><td>'+value["discount_percent"]+'</td><td>'+percent_input+'</td><td>₹ '+numberWithCommas(value["discount_amount"])+'</td><td>'+amount_input+'</td><td>'+value["scheme_code"]+'</td><td>'+value["scheme_end_date"]+'</td></tr>';
                        });

                        $("#schemes_body").html(table);
                        $('#modal-info').modal('show');
                    }, error: function(err){
                        // throw new Error('Failed to load options: test.')
                        console.log(err);
                    }
                });
            });

            $(document).on('click', '.editScheme', function() {

                checkedData = [];
                var id = this.id.split('_')[1]
                $.ajax({
                    type:'get',
                    url:'/user/applyed_scheme?id='+id,
                    success: function(res){

                        var table = "";
                        $.each(res["data"], function(index, value) {
                            var checkbox = '<input id="check_'+value["order_id"]+'_'+value["scheme_id"]+'" class="checkClass" value="'+value["scheme_id"]+'" type="checkbox" onclick="pushValue(this.id)">';
                            var percent_input = '<input id="percent_'+value["order_id"]+'_'+value["scheme_id"]+'" class="scheme-input" type="number" min="0" max="'+value["discount_percent"]+'" placeholder="%" value="'+value["percent"]+'">';
                            var amount_input = '<input id="amount_'+value["order_id"]+'_'+value["scheme_id"]+'" class="scheme-input" type="number" min="0" max="'+value["discount_amount"]+'" placeholder="INR" value="'+value["amount"]+'">';

                            table += '<tr><td>'+checkbox+'</td><td>'+value["scheme_name"]+'</td><td>'+value["discount_percent"]+'</td><td>'+percent_input+'</td><td>₹ '+numberWithCommas(value["discount_amount"])+'</td><td>'+amount_input+'</td><td>'+value["scheme_code"]+'</td><td>'+value["scheme_end_date"]+'</td></tr>';
                        });

                        $("#schemes_body").html(table);
                        $('#modal-info').modal('show');
                    }, error: function(err){
                        // throw new Error('Failed to load options: test.')
                        console.log(err);
                    }
                });
            });

            $(".scheme-input").keypress(function (e) {
                if (e.which != 8 && e.which != 0 && e.which != 46 && (e.which < 48 || e.which > 57)) {
                    return false;
                }
            });

            $(".input-max").keypress(function (e) {
                if (e.which != 8 && e.which != 0 && e.which != 46 && (e.which < 48 || e.which > 57)) {
                    return false;
                }
            });

            $(document).on('change', "input.scheme-input", function() {

                if(parseFloat($(this).val()) >= 0 && parseFloat($(this).val()) <= parseFloat($(this).attr('max'))) {

                    var button = $('#apply_scheme');
                    // var data = $(this).parents('tr').find('[type=checkbox]').val()
                    var data = this.id.split('_')[1]+'_'+this.id.split('_')[2];
                    var percent = $('#percent_'+data).val();
                    if (percent == '')
                        percent = 0;
                    var amount = $('#amount_'+data).val();
                    if (amount == '')
                        amount = 0;

                    $.each(checkedData, function(index, value) {
                        if(checkedData[index].indexOf(data) != -1){
                            // var index = checkedData.indexOf(data);
                            checkedData[index] = data+'_'+percent+'_'+amount
                        }
                    })
                    button.prop('disabled', false);
                }
                else if (parseFloat($(this).val()) > parseFloat($(this).attr('max'))) {

                    toastr.error('your max discount is '+ $(this).attr('max'));
                    var button = $('#apply_scheme');

                    button.prop('disabled', true);
                }
            });

            $('#apply_scheme').click(function(){

                if (checkedData.length > 0){

                    apply_tieup_with_scheme()

                    var product = checkedData[0].split('_')[0];
                    var checkedScheme = checkedData.join('|');
                    var tieup = $('#tieup_' + product).val();
                    if(tieup == "")
                        tieup = 0;

                    $.ajax({
                        type:'get',
                        url:'/user/apply_scheme?order='+product+'&scheme='+checkedScheme+'&tieup='+tieup,
                        success: function(res) {

                            $.each(checkedData, function(index, value) {
                                toastr.success(value.split('_')[2] + ' % and ' +value.split('_')[3]+ ' INR scheme successfully Applied!');
                            });
                            if (tieup > 0)
                                toastr.success(tieup + ' Tieup successfully Applied!');

                            checkedData = []
                            $('#modal-info').modal('hide');
                            bind_data(res)
                            // toastr.success('Scheme successfully updated!');

                        }, error: function(err) {
                            checkedData = [];
                            // throw new Error('Failed to load options: test.')
                            console.log(err);
                        }
                    });
                }
                else {
                    toastr.warning('Please check your scheme');
                }
            })

            $('#submit').click(function(){

                var tieupList = [];
                var empty = [];
                $('[id^="tieup_"]').each(function() {
                    var product = $(this).attr('group');
                    var tieup = $(this).val();
                    if(tieup=="")
                        tieup=0;

                    tieupList.push(product+'_'+tieup)
                    if(tieup != "" && tieup != null && tieup != undefined)
                        empty.push($(this).val());
                });
                var tieUP = tieupList.join('|');
                if(empty.length > 0) {
                    $.ajax({
                        type:'get',
                        url:'/user/apply_tieup?order='+order+'&tieup='+tieUP,
                        success: function(res){

                            $.each(tieupList, function(index, value) {
                                toastr.success(value.split('_')[1] + ' Tieup successfully Applied!');
                            });

                            tieupList = []
                            empty = []
                            bind_data(res)
                        }, error: function(err){
                            // throw new Error('Failed to load options: test.')
                            console.log(err);
                        }
                    });
                }
                else {
                    toastr.error('Please add Tieup!');
                }
            });

            $(document).on('change', '[id^="tieup_"]', function() {

                if(parseFloat($(this).val()) >= 0 && parseFloat($(this).val()) <= parseFloat($(this).attr('max'))) {

                    var button = $('#submit');

                    var currid = this.id.split('_')[1];
                    var tieup = $('#tieup_'+currid).val();
                    var pregst = $('#pregst_'+currid).val();
                    var discount = pregst*tieup/100;
                    var final = pregst - discount;
                    var qty = $('#qty_'+currid).val();

                    $('#final_'+currid).html('₹ ' + numberWithCommas(final.toFixed(2)));
                    $('#total_'+currid).html('₹ ' + numberWithCommas((final*qty).toFixed(2)));

                    button.prop('disabled', false);
                }
                else {

                    toastr.error('please enter valid tieup');
                    // var button = $('#submit');
                    // button.prop('disabled', true);
                }
            });

            $(document).on('click', '.delete-applyed', function() {

                var scheme = this.id.split('_')[1]
                $("#confirm-id").attr("group", scheme);

                $('#modal-danger').modal('show');
            });

            $("#confirm-id").click(function () {

                var scheme_id = $(this).attr("group");
                $.ajax({
                    type:'get',
                    url:'/user/delete_scheme?order='+order+'&scheme='+scheme_id,
                    success: function(res){
                        $('#modal-danger').modal('hide');
                        bind_data(res)
                        toastr.success('Scheme successfully deleted!');
                    }, error: function(err) {
                        $('#modal-danger').modal('hide');
                        // throw new Error('Failed to load options: test.')
                        console.log(err);
                    }
                });
            });

            // Send Scheme to dealer
            $(".send-dealer").click(function(){

                var dealerList = [];
                $('[id^="pregst_"]').each(function() {
                    var product = this.id.split('_')[1];
                    var pregst = $(this).val();
                    if(pregst=="")
                        pregst=0;

                    dealerList.push(product+'_'+pregst)
                });
                var dealerData = dealerList.join('|');

                if(dealerList.length > 0) {
                    $.ajax({
                        type:'get',
                        url:'/user/send_to_dealer?order='+order+'&dealer='+dealerData,
                        success: function(res){
                            toastr.success('Successfully sent to dealer!');
                        }, error: function(err){
                            // throw new Error('Failed to load options: test.')
                            console.log(err);
                        }
                    });
                }
            });

            $(".edit-btn").click(function(){

                $('[id^="tieup_"]').each(function() {
                    $(this).attr('disabled', false);
                });
                $(".apply-btn").css('display', 'inline-block');
                $(".edit-btn").css('display', 'none');
            });

            getAllProduct()
        });


        function getAllProduct() {
            $.ajax({
                type: 'get',
                url: '/user/get_products?order='+order,
                success: function(res) {
                    bind_data(res)
                }, error: function(err) {
                    throw new Error('Failed to load options: test.')
                }
            });
        }

        function bind_data(res) {
            var table = "";
            $.each(res["data"], function(index, value) {

                var tieup_input = '<input id="tieup_'+value["pk"]+'" group="'+value["pk"]+'" class="input-max" type="number" min="0" max="'+value["tie_up"]+'" placeholder="0" value="'+value["apply_tieup"]+'" style="width:100%;max-width:62px;"><br> <b style="font-size:11px;">Max '+value["tie_up"]+'</b>';
                var pregst_hidden_input = '<input id="pregst_'+value["pk"]+'" type="hidden" value="'+value["pregst"]+'">₹ '+numberWithCommas(value["total_pre"].toFixed(2));
                var qty_hidden_input = '<input id="qty_'+value["pk"]+'" type="hidden" value="'+value["quantity"]+'">'+value["quantity"];

                var applyed="";
                $.each(value["apply_schemes"], function(i, v) {
                    applyed += '<p class="label label-success" style="margin-right:2%;cursor:pointer;"><span id="apply_'+v["scheme_id"]+'" class="editScheme">'+v["scheme_name"]+'</span><i id="delete_'+v["scheme_id"]+'" class="fa fa-times delete-applyed" style="vertical-align: super;"></i></p>';
                });

                if(value['available_scheme'] == true)
                    applyed += '<a id="showScheme_'+value["pk"]+'" href="javascript:void(0);" class="apply-scheme" style="display: block;margin-top: 4%;"><i class="fa fa-plus"></i> Add Schemes</a>';
                else
                    applyed += '<a href="javascript:void(0);" style="display: block;margin-top: 4%;color: #83b5d2;"> No Schemes Available</a>';

                table += '<tr><td>'+value["skucode"]+'</td><td>'+qty_hidden_input+'</td><td style="text-align:right;">₹ '+numberWithCommas(value["dp"].toFixed(2))+'</td><td style="text-align:right;">'+value["allowance"]+' %</td><td style="text-align:right;">'+pregst_hidden_input+'</td><td>'+tieup_input+'</td><td>'+applyed+'</td><td id="final_'+value["pk"]+'" style="text-align:right;">₹ '+numberWithCommas(value["total_pre_gst"].toFixed(2))+'</td><td id="total_'+value["pk"]+'" style="text-align:right;">₹ '+numberWithCommas(value["final_total"].toFixed(2))+'</td><td style="text-align:right;">₹ '+ numberWithCommas(value["bbp"].toFixed(2))+'</td></tr>';
            });

            $("#dp").html('₹ ' + numberWithCommas(res["total"]["sr_total"].toFixed(2)));
            $("#gst").html('₹ ' + numberWithCommas(res["total"]["less_tieup"].toFixed(2)));
            // $("#allowance").html(res["total"]["allowance"] + ' % Allowance')
            $("#pre").html('₹ ' + numberWithCommas(res["total"]["less_sell"].toFixed(2)));
            $("#cgst").html('₹ ' + numberWithCommas(res["total"]["net_bill"].toFixed(2)));

            $("#products_body").html(table);

            if(res["total"]["tieup_flag"] == true || res["total"]["scheme_flag"] == true) {
                $(".table-hide").slideDown("slow");
                // $(".apply-btn").html("<a href='javascript:void(0);'>Edit Scheme</a>");

                if(res["total"]["tieup_flag"] == true) {
                    $('[id^="tieup_"]').each(function() {
                        $(this).attr('disabled', true);
                    });
                    // $(".apply-btn").html("<a href='javascript:void(0);'>Edit Scheme</a>");
                    $(".apply-btn").css('display', 'none');
                    $(".edit-btn").css('display', 'inline-block');
                }
                else {
                    $(".apply-btn").css('display', 'inline-block');
                    $(".edit-btn").css('display', 'none');
                }
            }
            else {
                $(".table-hide").addClass("table-hide");
                // $(".apply-btn").html("<a href='javascript:void(0);'>Apply Scheme</a>");
                $(".apply-btn").css('display', 'inline-block');
                $(".edit-btn").css('display', 'none');
            }

            // $(".apply-btn").html("<a href='javascript:void(0);'>Edit Scheme</a>");
        }

        <!--....................................................................-->

        function apply_tieup_with_scheme(){
            var tieupList = [];
            var empty = [];
            $('[id^="tieup_"]').each(function() {
                var product = $(this).attr('group');
                var tieup = $(this).val();
                if(tieup=="")
                    tieup=0;

                tieupList.push(product+'_'+tieup)
                if(tieup != "" && tieup != null && tieup != undefined)
                    empty.push($(this).val());
            });
            var tieUP = tieupList.join('|');

            $.ajax({
                type:'get',
                url:'/user/apply_tieup?order='+order+'&tieup='+tieUP,
                success: function(res){
                    $.each(tieupList, function(index, value) {
                        toastr.success(value.split('_')[1] + ' Tieup successfully Applied!');
                    });
                    tieupList = []
                    empty = []
                    bind_data(res)
                }, error: function(err){
                    // throw new Error('Failed to load options: test.')
                    console.log(err);
                }
            });
        }


        //==================== ********************************* ===========================//
        //==================== **** New changes in checkbox **** ==========================//
        //==================== Reverse all checkbox functionality =========================//
        //==================== ********************************* ========================//


        function checkAllCheckBox() {

            $("#main_checkbox").change(function () {
                if ($(this).prop('checked')) {
                    $(".checkClass").prop('checked', true);

                    $('.checkClass:checked').each(function () {
                        var currid = this.id;
                        var checkboxid = $('#' + currid).val();
                        if (checkedData.indexOf(checkboxid) == -1) {
                            checkedData.push(checkboxid);
                        }
                    });
                }
                else {
                    $(".checkClass").removeAttr('checked');
                    $(".checkClass").prop('checked', false);

                    $('.checkClass:not(:checked)').each(function () {
                        var currid = this.id;
                        var checkboxid = $('#' + currid).val();
                        checkedData = $.grep(checkedData, function (value) {
                            return value != checkboxid;
                        });
                    });
                }
            });
        }


        function pushValue(currid) {

            if ($('#' + currid).prop('checked')) {

                var uniqid = currid;
                // var data = uniqid.split('_')[1];
                var data = uniqid.split('_')[1]+'_'+uniqid.split('_')[2];
                var percent = $('#percent_'+data).val();
                if (percent=='')
                    percent = 0;
                var amount = $('#amount_'+data).val();
                if (amount == '')
                    amount = 0;

                if((percent != 0 && percent != '' && percent != undefined) || (amount != 0 && amount != '' && amount != undefined)) {
                    if ($('.checkClass:checked').length == $('.checkClass').length) {
                        $("#main_checkbox").prop('checked', true);
                    }
                    $('#' + currid).val(data+'_'+percent+'_'+amount)
                    var checkboxid = $('#' + currid).val();
                    if (checkedData.indexOf(checkboxid) == -1) {
                        checkedData.push(checkboxid);
                    }
                }
                else {
                    $('#' + currid).removeAttr('checked');
                    $('#' + currid).prop('checked', false);
                    toastr.warning('please add discount value');
                }
            }
            else {
                $("#main_checkbox").removeAttr('checked');
                $("#main_checkbox").prop('checked', false);

                var uniqid = currid;
                // var data = uniqid.split('_')[1];
                var data = uniqid.split('_')[1]+'_'+uniqid.split('_')[2];
                var percent = $('#percent_'+data).val();
                if (percent=='')
                    percent = 0;
                var amount = $('#amount_'+data).val();
                if (amount == '')
                    amount = 0;

                $('#' + currid).val(data+'_'+percent+'_'+amount)
                var checkboxid = $('#' + currid).val();
                checkedData = $.grep(checkedData, function (value) {
                    return value != checkboxid;
                });
            }
        }

        function numberWithCommas(number) {
            var parts = number.toString().split(".");
            parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
            return parts.join(".");
        }

        //============ only for testing
        function showCheckedCheckBoxData() {
            alert(checkedData);
        }
    </script>
{% endblock %}